@ticket-BB-17328
@ticket-BB-18470
@fixture-OroCatalogBundle:import_export_categories.yml

Feature: Import Export Categories
  In order to manage big collections of categories
  As an administrator
  I want to have an ability to export and import categories

  Scenario: Data Template for Categories
    Given I login as administrator
    And I go to Products/ Master Catalog
    When I download "Categories" Data Template file
    Then I see the following columns in exact order in the downloaded csv template:
      | id                                 |
      | titles.default.fallback            |
      | titles.default.value               |
      | titles.English.fallback            |
      | titles.English.value               |
      | parentCategory.id                  |
      | parentCategory.title               |
      | slugPrototypes.default.fallback    |
      | slugPrototypes.default.value       |
      | slugPrototypes.English.fallback    |
      | slugPrototypes.English.value       |
      | shortDescriptions.default.fallback |
      | shortDescriptions.default.value    |
      | shortDescriptions.English.fallback |
      | shortDescriptions.English.value    |
      | longDescriptions.default.fallback  |
      | longDescriptions.default.value     |
      | longDescriptions.English.fallback  |
      | longDescriptions.English.value     |
      | metaTitles.default.fallback        |
      | metaTitles.default.value           |
      | metaTitles.English.fallback        |
      | metaTitles.English.value           |
      | metaDescriptions.default.fallback  |
      | metaDescriptions.default.value     |
      | metaDescriptions.English.fallback  |
      | metaDescriptions.English.value     |
      | metaKeywords.default.fallback      |
      | metaKeywords.default.value         |
      | metaKeywords.English.fallback      |
      | metaKeywords.English.value         |

  Scenario: Import Categories
    Given I run export for "Categories"
    And I fill template with data:
      | id                                                                                | titles.default.fallback | titles.default.value                                                              | titles.English.fallback | titles.English.value                          | parentCategory.id                                                           | parentCategory.title                                                                                                                                                                                                                                                                   | shortDescriptions.default.fallback | shortDescriptions.default.value | shortDescriptions.English.fallback | shortDescriptions.English.value          | longDescriptions.default.fallback | longDescriptions.default.value | longDescriptions.English.fallback | longDescriptions.English.value          | metaDescriptions.default.fallback | metaDescriptions.default.value | metaDescriptions.English.fallback | metaDescriptions.English.value          | metaKeywords.default.fallback | metaKeywords.default.value | metaKeywords.English.fallback | metaKeywords.English.value           | metaTitles.default.fallback | metaTitles.default.value | metaTitles.English.fallback | metaTitles.English.value           | slugPrototypes.default.fallback | slugPrototypes.default.value     | slugPrototypes.English.fallback | slugPrototypes.English.value        |
      |                                                                                   |                         | 1 new category + invalid parent id + empty parent title                           |                         |                                               | 999999                                                                      |                                                                                                                                                                                                                                                                                        |                                    |                                 |                                    |                                          |                                   |                                |                                   |                                         |                                   |                                |                                   |                                         |                               |                            |                               |                                      |                             |                          |                             |                                    |                                 |                                  |                                 |                                     |
      |                                                                                   |                         | 2 new category + empty parent id + invalid parent title                           |                         |                                               |                                                                             | Non-existent category                                                                                                                                                                                                                                                                  |                                    |                                 |                                    |                                          |                                   |                                |                                   |                                         |                                   |                                |                                   |                                         |                               |                            |                               |                                      |                             |                          |                             |                                    |                                 |                                  |                                 |                                     |
      |                                                                                   |                         | 3 new category + existing parent id + empty parent title                          |                         |                                               | 1                                                                           |                                                                                                                                                                                                                                                                                        |                                    |                                 |                                    |                                          |                                   |                                |                                   |                                         |                                   |                                |                                   |                                         |                               |                            |                               |                                      |                             |                          |                             |                                    |                                 |                                  |                                 |                                     |
      |                                                                                   |                         | 4 new category + empty parent id + empty parent title                             |                         |                                               |                                                                             |                                                                                                                                                                                                                                                                                        |                                    |                                 |                                    |                                          |                                   |                                |                                   |                                         |                                   |                                |                                   |                                         |                               |                            |                               |                                      |                             |                          |                             |                                    |                                 |                                  |                                 |                                     |
      |                                                                                   |                         | 5 new category + empty parent id + existing parent title                          |                         |                                               |                                                                             | All Products                                                                                                                                                                                                                                                                           |                                    |                                 |                                    |                                          |                                   |                                |                                   |                                         |                                   |                                |                                   |                                         |                               |                            |                               |                                      |                             |                          |                             |                                    |                                 |                                  |                                 |                                     |
      |                                                                                   |                         | 6.3 new category + empty parent id + title of new category (postponed)            |                         |                                               |                                                                             | All Products / 6 new category + empty parent id + title of new category (postponed) / 6.1 new category + empty parent id + title of new category (postponed) / 6.2 new category + empty parent id + title of new category (postponed)                                                  |                                    |                                 |                                    |                                          |                                   |                                |                                   |                                         |                                   |                                |                                   |                                         |                               |                            |                               |                                      |                             |                          |                             |                                    |                                 |                                  |                                 |                                     |
      |                                                                                   |                         | 6.2 new category + empty parent id + title of new category (postponed)            |                         |                                               |                                                                             | All Products / 6 new category + empty parent id + title of new category (postponed) / 6.1 new category + empty parent id + title of new category (postponed)                                                                                                                           |                                    |                                 |                                    |                                          |                                   |                                |                                   |                                         |                                   |                                |                                   |                                         |                               |                            |                               |                                      |                             |                          |                             |                                    |                                 |                                  |                                 |                                     |
      |                                                                                   |                         | 6.1 new category + empty parent id + title of new category (postponed)            |                         |                                               |                                                                             | All Products / 6 new category + empty parent id + title of new category (postponed)                                                                                                                                                                                                    |                                    |                                 |                                    |                                          |                                   |                                |                                   |                                         |                                   |                                |                                   |                                         |                               |                            |                               |                                      |                             |                          |                             |                                    |                                 |                                  |                                 |                                     |
      |                                                                                   |                         | 6 new category + empty parent id + title of new category (postponed)              |                         |                                               |                                                                             | All Products                                                                                                                                                                                                                                                                           |                                    |                                 |                                    |                                          |                                   |                                |                                   |                                         |                                   |                                |                                   |                                         |                               |                            |                               |                                      |                             |                          |                             |                                    |                                 |                                  |                                 |                                     |
      |                                                                                   |                         | 7 new category + empty parent id + title of new category                          |                         |                                               |                                                                             | All Products                                                                                                                                                                                                                                                                           |                                    |                                 |                                    |                                          |                                   |                                |                                   |                                         |                                   |                                |                                   |                                         |                               |                            |                               |                                      |                             |                          |                             |                                    |                                 |                                  |                                 |                                     |
      |                                                                                   |                         | 7.1 new category + empty parent id + title of new category                        |                         |                                               |                                                                             | All Products / 7 new category + empty parent id + title of new category                                                                                                                                                                                                                |                                    |                                 |                                    |                                          |                                   |                                |                                   |                                         |                                   |                                |                                   |                                         |                               |                            |                               |                                      |                             |                          |                             |                                    |                                 |                                  |                                 |                                     |
      |                                                                                   |                         | 7.2 new category + empty parent id + title of new category                        |                         |                                               |                                                                             | All Products / 7 new category + empty parent id + title of new category / 7.1 new category + empty parent id + title of new category                                                                                                                                                   |                                    |                                 |                                    |                                          |                                   |                                |                                   |                                         |                                   |                                |                                   |                                         |                               |                            |                               |                                      |                             |                          |                             |                                    |                                 |                                  |                                 |                                     |
      |                                                                                   |                         | 7.3 new category + empty parent id + title of new category                        |                         |                                               |                                                                             | All Products / 7 new category + empty parent id + title of new category / 7.1 new category + empty parent id + title of new category / 7.2 new category + empty parent id + title of new category                                                                                      |                                    |                                 |                                    |                                          |                                   |                                |                                   |                                         |                                   |                                |                                   |                                         |                               |                            |                               |                                      |                             |                          |                             |                                    |                                 |                                  |                                 |                                     |
      | <valueFromExportFile("id", "titles.default.value", "existing category 1")>        |                         | 8 existing category + invalid parent id                                           |                         |                                               | 9999999                                                                     |                                                                                                                                                                                                                                                                                        |                                    |                                 |                                    |                                          |                                   |                                |                                   |                                         |                                   |                                |                                   |                                         |                               |                            |                               |                                      |                             |                          |                             |                                    |                                 |                                  |                                 |                                     |
      | <valueFromExportFile("id", "titles.default.value", "existing category 2")>        |                         | 9 existing category + empty parent id + invalid parent title                      |                         |                                               |                                                                             | Non-existent category                                                                                                                                                                                                                                                                  |                                    |                                 |                                    |                                          |                                   |                                |                                   |                                         |                                   |                                |                                   |                                         |                               |                            |                               |                                      |                             |                          |                             |                                    |                                 |                                  |                                 |                                     |
      | <valueFromExportFile("id", "titles.default.value", "existing category 3")>        |                         | 10 existing category + empty parent id + empty parent title                       |                         |                                               |                                                                             |                                                                                                                                                                                                                                                                                        |                                    |                                 |                                    |                                          |                                   |                                |                                   |                                         |                                   |                                |                                   |                                         |                               |                            |                               |                                      |                             |                          |                             |                                    |                                 |                                  |                                 |                                     |
      |                                                                                   |                         | new category 1                                                                    |                         |                                               |                                                                             |                                                                                                                                                                                                                                                                                        |                                    |                                 |                                    |                                          |                                   |                                |                                   |                                         |                                   |                                |                                   |                                         |                               |                            |                               |                                      |                             |                          |                             |                                    |                                 |                                  |                                 |                                     |
      | <valueFromExportFile("id", "titles.default.value", "existing category 4")>        |                         | 11 existing category + empty parent id + title of new category                    |                         |                                               |                                                                             | All Products / new category 1                                                                                                                                                                                                                                                          |                                    |                                 |                                    |                                          |                                   |                                |                                   |                                         |                                   |                                |                                   |                                         |                               |                            |                               |                                      |                             |                          |                             |                                    |                                 |                                  |                                 |                                     |
      | <valueFromExportFile("id", "titles.default.value", "existing category 5")>        |                         | 12 existing category + empty parent id + title of new category (postponed)        |                         |                                               |                                                                             | All Products / new category 2                                                                                                                                                                                                                                                          |                                    |                                 |                                    |                                          |                                   |                                |                                   |                                         |                                   |                                |                                   |                                         |                               |                            |                               |                                      |                             |                          |                             |                                    |                                 |                                  |                                 |                                     |
      |                                                                                   |                         | new category 2                                                                    |                         |                                               |                                                                             |                                                                                                                                                                                                                                                                                        |                                    |                                 |                                    |                                          |                                   |                                |                                   |                                         |                                   |                                |                                   |                                         |                               |                            |                               |                                      |                             |                          |                             |                                    |                                 |                                  |                                 |                                     |
      | <valueFromExportFile("id", "titles.default.value", "existing category 6")>        |                         | 13 existing category + empty parent id + existing parent title                    |                         |                                               |                                                                             |                                                                                                                                                                                                                                                                                        |                                    |                                 |                                    |                                          |                                   |                                |                                   |                                         |                                   |                                |                                   |                                         |                               |                            |                               |                                      |                             |                          |                             |                                    |                                 |                                  |                                 |                                     |
      | <valueFromExportFile("id", "titles.default.value", "existing category 7")>        |                         | 13.1 existing category + empty parent id + existing parent title                  |                         |                                               |                                                                             | All Products / 13 existing category + empty parent id + existing parent title                                                                                                                                                                                                          |                                    |                                 |                                    |                                          |                                   |                                |                                   |                                         |                                   |                                |                                   |                                         |                               |                            |                               |                                      |                             |                          |                             |                                    |                                 |                                  |                                 |                                     |
      | <valueFromExportFile("id", "titles.default.value", "existing category 8")>        |                         | 13.2 existing category + empty parent id + existing parent title                  |                         |                                               |                                                                             | All Products / 13 existing category + empty parent id + existing parent title / 13.1 existing category + empty parent id + existing parent title                                                                                                                                       |                                    |                                 |                                    |                                          |                                   |                                |                                   |                                         |                                   |                                |                                   |                                         |                               |                            |                               |                                      |                             |                          |                             |                                    |                                 |                                  |                                 |                                     |
      | <valueFromExportFile("id", "titles.default.value", "existing category 9")>        |                         | 13.3 existing category + empty parent id + existing parent title                  |                         |                                               |                                                                             | All Products / 13 existing category + empty parent id + existing parent title / 13.1 existing category + empty parent id + existing parent title / 13.2 existing category + empty parent id + existing parent title                                                                    |                                    |                                 |                                    |                                          |                                   |                                |                                   |                                         |                                   |                                |                                   |                                         |                               |                            |                               |                                      |                             |                          |                             |                                    |                                 |                                  |                                 |                                     |
      | <valueFromExportFile("id", "titles.default.value", "existing category 10")>       |                         | 14 existing category + existing parent id + existing parent title                 |                         |                                               | <valueFromExportFile("id", "titles.default.value", "existing category 11")> | All Products / existing category 12                                                                                                                                                                                                                                                    |                                    |                                 |                                    |                                          |                                   |                                |                                   |                                         |                                   |                                |                                   |                                         |                               |                            |                               |                                      |                             |                          |                             |                                    |                                 |                                  |                                 |                                     |
      | <valueFromExportFile("id", "titles.default.value", "existing category 13")>       |                         | 15 existing category + existing parent id + empty parent title                    |                         |                                               | <valueFromExportFile("id", "titles.default.value", "existing category 14")> |                                                                                                                                                                                                                                                                                        |                                    |                                 |                                    |                                          |                                   |                                |                                   |                                         |                                   |                                |                                   |                                         |                               |                            |                               |                                      |                             |                          |                             |                                    |                                 |                                  |                                 |                                     |
      | <valueFromExportFile("id", "titles.default.value", "existing category 15")>       |                         | existing category 15 (updated)                                                    |                         |                                               |                                                                             |                                                                                                                                                                                                                                                                                        |                                    |                                 |                                    |                                          |                                   |                                |                                   |                                         |                                   |                                |                                   |                                         |                               |                            |                               |                                      |                             |                          |                             |                                    |                                 |                                  |                                 |                                     |
      | <valueFromExportFile("id", "titles.default.value", "existing category 16")>       |                         | 15 existing category + empty parent id + new title of existing parent             |                         |                                               |                                                                             | All Products / existing category 15 (updated)                                                                                                                                                                                                                                          |                                    |                                 |                                    |                                          |                                   |                                |                                   |                                         |                                   |                                |                                   |                                         |                               |                            |                               |                                      |                             |                          |                             |                                    |                                 |                                  |                                 |                                     |
      | <valueFromExportFile("id", "titles.default.value", "existing category 17")>       |                         | 16 existing category + empty parent id + old title of existing parent             |                         |                                               |                                                                             | All Products / existing category 15                                                                                                                                                                                                                                                    |                                    |                                 |                                    |                                          |                                   |                                |                                   |                                         |                                   |                                |                                   |                                         |                               |                            |                               |                                      |                             |                          |                             |                                    |                                 |                                  |                                 |                                     |
      | <valueFromExportFile("id", "titles.default.value", "existing category 18")>       |                         | existing category 18 (updated)                                                    |                         |                                               |                                                                             |                                                                                                                                                                                                                                                                                        |                                    |                                 |                                    |                                          |                                   |                                |                                   |                                         |                                   |                                |                                   |                                         |                               |                            |                               |                                      |                             |                          |                             |                                    |                                 |                                  |                                 |                                     |
      |                                                                                   |                         | 17 new category + empty parent id + new title of existing parent                  |                         |                                               |                                                                             | All Products / existing category 18 (updated)                                                                                                                                                                                                                                          |                                    |                                 |                                    |                                          |                                   |                                |                                   |                                         |                                   |                                |                                   |                                         |                               |                            |                               |                                      |                             |                          |                             |                                    |                                 |                                  |                                 |                                     |
      |                                                                                   |                         | 18 new category + empty parent id + old title of existing parent                  |                         |                                               |                                                                             | All Products / existing category 18                                                                                                                                                                                                                                                    |                                    |                                 |                                    |                                          |                                   |                                |                                   |                                         |                                   |                                |                                   |                                         |                               |                            |                               |                                      |                             |                          |                             |                                    |                                 |                                  |                                 |                                     |
      |                                                                                   |                         | 19 new category + empty parent id + new title of existing parent (postponed)      |                         |                                               |                                                                             | All Products / existing category 20 (updated)                                                                                                                                                                                                                                          |                                    |                                 |                                    |                                          |                                   |                                |                                   |                                         |                                   |                                |                                   |                                         |                               |                            |                               |                                      |                             |                          |                             |                                    |                                 |                                  |                                 |                                     |
      | <valueFromExportFile("id", "titles.default.value", "existing category 19")>       |                         | 20 existing category + empty parent id + new title of existing parent (postponed) |                         |                                               |                                                                             | All Products / existing category 20 (updated)                                                                                                                                                                                                                                          |                                    |                                 |                                    |                                          |                                   |                                |                                   |                                         |                                   |                                |                                   |                                         |                               |                            |                               |                                      |                             |                          |                             |                                    |                                 |                                  |                                 |                                     |
      | <valueFromExportFile("id", "titles.default.value", "existing category 20")>       |                         | existing category 20 (updated)                                                    |                         |                                               |                                                                             |                                                                                                                                                                                                                                                                                        |                                    |                                 |                                    |                                          |                                   |                                |                                   |                                         |                                   |                                |                                   |                                         |                               |                            |                               |                                      |                             |                          |                             |                                    |                                 |                                  |                                 |                                     |
      | <valueFromExportFile("id", "titles.default.value", "existing category 21")>       |                         | 21 existing category can be updated                                               |                         | 21 existing category can be updated (english) | 1                                                                           | All Products                                                                                                                                                                                                                                                                           |                                    | Short description updated       |                                    | Short description updated (english)      |                                   | Long description updated       |                                   | Long description updated (english)      |                                   | Meta description updated       |                                   | Meta description updated                |                               | Meta keywords updated      |                               | Meta keywords updated (english)      |                             | Meta titles updated      |                             | Meta titles updated (english)      |                                 | existing-category-filled-updated |                                 | existing-category-filled-updated-en |
      |                                                                                   |                         | 22 new filled category                                                            |                         | 22 new filled category (english)              | 1                                                                           | All Products                                                                                                                                                                                                                                                                           |                                    | New category short description  |                                    | New category short description (english) |                                   | New category long description  |                                   | New category long description (english) |                                   | New category meta description  |                                   | New category meta description (english) |                               | New category meta keywords |                               | New category meta keywords (english) |                             | New category meta titles |                             | New category meta titles (english) |                                 | new-category-filled              |                                 | new-category-filled-en              |
      |                                                                                   |                         | 23 "c@t+e3g,O\r=y"/'with' `/` $s:p-e_c+i%a^l; {[(<#chars&>)]}*.                   |                         |                                               |                                                                             |                                                                                                                                                                                                                                                                                        |                                    |                                 |                                    |                                          |                                   |                                |                                   |                                         |                                   |                                |                                   |                                         |                               |                            |                               |                                      |                             |                          |                             |                                    |                                 |                                  |                                 |                                     |
      | <valueFromExportFile("id", "titles.default.value", "category with tree level 1")> |                         | category with tree level 5                                                        |                         |                                               |                                                                             | All Products / 13 existing category + empty parent id + existing parent title / 13.1 existing category + empty parent id + existing parent title / 13.2 existing category + empty parent id + existing parent title / 13.3 existing category + empty parent id + existing parent title |                                    |                                 |                                    |                                          |                                   |                                |                                   |                                         |                                   |                                |                                   |                                         |                               |                            |                               |                                      |                             |                          |                             |                                    |                                 |                                  |                                 |                                     |

    When I import file
    Then Email should contains the following "Errors: 13 processed: 35, read: 39, added: 18, updated: 0, replaced: 17" text
    When I reload the page
    Then I should not see "1 new category + invalid parent id + empty parent title"
    And I should not see "2 new category + empty parent id + invalid parent title"
    And I should see "3 new category + existing parent id + empty parent title" belongs to "All Products" in tree
    And I should see "4 new category + empty parent id + empty parent title" belongs to "All Products" in tree
    And I should see "5 new category + empty parent id + existing parent title" belongs to "All Products" in tree
    And I should see "6 new category + empty parent id + title of new category (postponed)" belongs to "All Products" in tree
    And I expand "6 new category + empty parent id + title of new category (postponed)" in tree
    And I should see "6.1 new category + empty parent id + title of new category (postponed)" belongs to "6 new category + empty parent id + title of new category (postponed)" in tree
    And I expand "6.1 new category + empty parent id + title of new category (postponed)" in tree
    And I should see "6.2 new category + empty parent id + title of new category (postponed)" belongs to "6.1 new category + empty parent id + title of new category (postponed)" in tree
    And I expand "6.2 new category + empty parent id + title of new category (postponed)" in tree
    And I should see "6.3 new category + empty parent id + title of new category (postponed)" belongs to "6.2 new category + empty parent id + title of new category (postponed)" in tree
    And I should see "7 new category + empty parent id + title of new category" belongs to "All Products" in tree
    And I expand "7 new category + empty parent id + title of new category" in tree
    And I should see "7.1 new category + empty parent id + title of new category" belongs to "7 new category + empty parent id + title of new category" in tree
    And I expand "7.1 new category + empty parent id + title of new category" in tree
    And I should see "7.2 new category + empty parent id + title of new category" belongs to "7.1 new category + empty parent id + title of new category" in tree
    And I expand "7.2 new category + empty parent id + title of new category" in tree
    And I should see "7.3 new category + empty parent id + title of new category" belongs to "7.2 new category + empty parent id + title of new category" in tree
    And I should see "existing category 1" belongs to "All Products" in tree
    And I should see "existing category 2" belongs to "All Products" in tree
    And I should see "10 existing category + empty parent id + empty parent title" belongs to "All Products" in tree
    And I should see "13 existing category + empty parent id + existing parent title" belongs to "All Products" in tree
    And I expand "13 existing category + empty parent id + existing parent title" in tree
    And I should see "13.1 existing category + empty parent id + existing parent title" belongs to "13 existing category + empty parent id + existing parent title" in tree
    And I expand "13.1 existing category + empty parent id + existing parent title" in tree
    And I should see "13.2 existing category + empty parent id + existing parent title" belongs to "13.1 existing category + empty parent id + existing parent title" in tree
    And I expand "13.2 existing category + empty parent id + existing parent title" in tree
    And I should see "13.3 existing category + empty parent id + existing parent title" belongs to "13.2 existing category + empty parent id + existing parent title" in tree
    And I should see "new category 1" belongs to "All Products" in tree
    And I expand "new category 1" in tree
    And I should see "11 existing category + empty parent id + title of new category" belongs to "new category 1" in tree
    And I should see "new category 2" belongs to "All Products" in tree
    And I expand "new category 2" in tree
    And I should see "12 existing category + empty parent id + title of new category (postponed)" belongs to "new category 2" in tree
    And I should see "existing category 11" belongs to "All Products" in tree
    And I expand "existing category 11" in tree
    And I should see "14 existing category + existing parent id + existing parent title" belongs to "existing category 11" in tree
    And I should see "existing category 12" belongs to "All Products" in tree
    And I should see "existing category 14" belongs to "All Products" in tree
    And I expand "existing category 14" in tree
    And I should see "15 existing category + existing parent id + empty parent title" belongs to "existing category 14" in tree
    And I should see "existing category 15 (updated)" belongs to "All Products" in tree
    And I expand "existing category 15 (updated)" in tree
    And I should see "15 existing category + empty parent id + new title of existing parent" belongs to "existing category 15 (updated)" in tree
    And I should see "16 existing category + empty parent id + old title of existing parent" belongs to "existing category 15 (updated)" in tree
    And I should see "existing category 18 (updated)" belongs to "All Products" in tree
    And I expand "existing category 18 (updated)" in tree
    And I should see "17 new category + empty parent id + new title of existing parent" belongs to "existing category 18 (updated)" in tree
    And I should see "18 new category + empty parent id + old title of existing parent" belongs to "existing category 18 (updated)" in tree
    And I should see "existing category 20 (updated)" belongs to "All Products" in tree
    And I expand "existing category 20 (updated)" in tree
    And I should see "19 new category + empty parent id + new title of existing parent (postponed)" belongs to "existing category 20 (updated)" in tree
    And I should see "20 existing category + empty parent id + new title of existing parent (postponed)" belongs to "existing category 20 (updated)" in tree
    And I should see "21 existing category can be updated" belongs to "All Products" in tree
    And I should see "22 new filled category" belongs to "All Products" in tree
    And I should see "c@t+e3g,O\r=y" belongs to "All Products" in tree
    And I should see "23 \"c@t+e3g,O\r=y\"/'with' `/` $s:p-e_c+i%a^l; {[(<\#chars&>)]}*."
    And tree level of category "category with tree level 5" is 5

  Scenario: Export Categories
    Given Exported file for "Categories" contains at least the following columns:
      | titles.default.fallback | titles.default.value                                                              | titles.English.fallback | titles.English.value                          | parentCategory.title                                                                                                                                                                                                                                                                   | shortDescriptions.default.fallback | shortDescriptions.default.value | shortDescriptions.English.fallback | shortDescriptions.English.value          | longDescriptions.default.fallback | longDescriptions.default.value | longDescriptions.English.fallback | longDescriptions.English.value          | metaDescriptions.default.fallback | metaDescriptions.default.value | metaDescriptions.English.fallback | metaDescriptions.English.value          | metaKeywords.default.fallback | metaKeywords.default.value | metaKeywords.English.fallback | metaKeywords.English.value           | metaTitles.default.fallback | metaTitles.default.value | metaTitles.English.fallback | metaTitles.English.value           | slugPrototypes.default.fallback | slugPrototypes.default.value     | slugPrototypes.English.fallback | slugPrototypes.English.value        |
      |                         | All Products                                                                      |                         |                                               |                                                                                                                                                                                                                                                                                        |                                    |                                 |                                    |                                          |                                   |                                |                                   |                                         |                                   |                                |                                   |                                         |                               |                            |                               |                                      |                             |                          |                             |                                    |                                 |                                  |                                 |                                     |
      |                         | existing category 1                                                               |                         |                                               | All Products                                                                                                                                                                                                                                                                           |                                    |                                 |                                    |                                          |                                   |                                |                                   |                                         |                                   |                                |                                   |                                         |                               |                            |                               |                                      |                             |                          |                             |                                    |                                 |                                  |                                 |                                     |
      |                         | existing category 2                                                               |                         |                                               | All Products                                                                                                                                                                                                                                                                           |                                    |                                 |                                    |                                          |                                   |                                |                                   |                                         |                                   |                                |                                   |                                         |                               |                            |                               |                                      |                             |                          |                             |                                    |                                 |                                  |                                 |                                     |
      |                         | 10 existing category + empty parent id + empty parent title                       |                         |                                               | All Products                                                                                                                                                                                                                                                                           |                                    |                                 |                                    |                                          |                                   |                                |                                   |                                         |                                   |                                |                                   |                                         |                               |                            |                               |                                      |                             |                          |                             |                                    |                                 |                                  |                                 |                                     |
      |                         | 11 existing category + empty parent id + title of new category                    |                         |                                               | All Products / new category 1                                                                                                                                                                                                                                                          |                                    |                                 |                                    |                                          |                                   |                                |                                   |                                         |                                   |                                |                                   |                                         |                               |                            |                               |                                      |                             |                          |                             |                                    |                                 |                                  |                                 |                                     |
      |                         | 12 existing category + empty parent id + title of new category (postponed)        |                         |                                               | All Products / new category 2                                                                                                                                                                                                                                                          |                                    |                                 |                                    |                                          |                                   |                                |                                   |                                         |                                   |                                |                                   |                                         |                               |                            |                               |                                      |                             |                          |                             |                                    |                                 |                                  |                                 |                                     |
      |                         | 13 existing category + empty parent id + existing parent title                    |                         |                                               | All Products                                                                                                                                                                                                                                                                           |                                    |                                 |                                    |                                          |                                   |                                |                                   |                                         |                                   |                                |                                   |                                         |                               |                            |                               |                                      |                             |                          |                             |                                    |                                 |                                  |                                 |                                     |
      |                         | 13.1 existing category + empty parent id + existing parent title                  |                         |                                               | All Products / 13 existing category + empty parent id + existing parent title                                                                                                                                                                                                          |                                    |                                 |                                    |                                          |                                   |                                |                                   |                                         |                                   |                                |                                   |                                         |                               |                            |                               |                                      |                             |                          |                             |                                    |                                 |                                  |                                 |                                     |
      |                         | 13.2 existing category + empty parent id + existing parent title                  |                         |                                               | All Products / 13 existing category + empty parent id + existing parent title / 13.1 existing category + empty parent id + existing parent title                                                                                                                                       |                                    |                                 |                                    |                                          |                                   |                                |                                   |                                         |                                   |                                |                                   |                                         |                               |                            |                               |                                      |                             |                          |                             |                                    |                                 |                                  |                                 |                                     |
      |                         | 13.3 existing category + empty parent id + existing parent title                  |                         |                                               | All Products / 13 existing category + empty parent id + existing parent title / 13.1 existing category + empty parent id + existing parent title / 13.2 existing category + empty parent id + existing parent title                                                                    |                                    |                                 |                                    |                                          |                                   |                                |                                   |                                         |                                   |                                |                                   |                                         |                               |                            |                               |                                      |                             |                          |                             |                                    |                                 |                                  |                                 |                                     |
      |                         | 14 existing category + existing parent id + existing parent title                 |                         |                                               | All Products / existing category 11                                                                                                                                                                                                                                                    |                                    |                                 |                                    |                                          |                                   |                                |                                   |                                         |                                   |                                |                                   |                                         |                               |                            |                               |                                      |                             |                          |                             |                                    |                                 |                                  |                                 |                                     |
      |                         | existing category 11                                                              |                         |                                               | All Products                                                                                                                                                                                                                                                                           |                                    |                                 |                                    |                                          |                                   |                                |                                   |                                         |                                   |                                |                                   |                                         |                               |                            |                               |                                      |                             |                          |                             |                                    |                                 |                                  |                                 |                                     |
      |                         | existing category 12                                                              |                         |                                               | All Products                                                                                                                                                                                                                                                                           |                                    |                                 |                                    |                                          |                                   |                                |                                   |                                         |                                   |                                |                                   |                                         |                               |                            |                               |                                      |                             |                          |                             |                                    |                                 |                                  |                                 |                                     |
      |                         | 15 existing category + existing parent id + empty parent title                    |                         |                                               | All Products / existing category 14                                                                                                                                                                                                                                                    |                                    |                                 |                                    |                                          |                                   |                                |                                   |                                         |                                   |                                |                                   |                                         |                               |                            |                               |                                      |                             |                          |                             |                                    |                                 |                                  |                                 |                                     |
      |                         | existing category 14                                                              |                         |                                               | All Products                                                                                                                                                                                                                                                                           |                                    |                                 |                                    |                                          |                                   |                                |                                   |                                         |                                   |                                |                                   |                                         |                               |                            |                               |                                      |                             |                          |                             |                                    |                                 |                                  |                                 |                                     |
      |                         | existing category 15 (updated)                                                    |                         |                                               | All Products                                                                                                                                                                                                                                                                           |                                    |                                 |                                    |                                          |                                   |                                |                                   |                                         |                                   |                                |                                   |                                         |                               |                            |                               |                                      |                             |                          |                             |                                    |                                 |                                  |                                 |                                     |
      |                         | 15 existing category + empty parent id + new title of existing parent             |                         |                                               | All Products / existing category 15 (updated)                                                                                                                                                                                                                                          |                                    |                                 |                                    |                                          |                                   |                                |                                   |                                         |                                   |                                |                                   |                                         |                               |                            |                               |                                      |                             |                          |                             |                                    |                                 |                                  |                                 |                                     |
      |                         | 16 existing category + empty parent id + old title of existing parent             |                         |                                               | All Products / existing category 15 (updated)                                                                                                                                                                                                                                          |                                    |                                 |                                    |                                          |                                   |                                |                                   |                                         |                                   |                                |                                   |                                         |                               |                            |                               |                                      |                             |                          |                             |                                    |                                 |                                  |                                 |                                     |
      |                         | existing category 18 (updated)                                                    |                         |                                               | All Products                                                                                                                                                                                                                                                                           |                                    |                                 |                                    |                                          |                                   |                                |                                   |                                         |                                   |                                |                                   |                                         |                               |                            |                               |                                      |                             |                          |                             |                                    |                                 |                                  |                                 |                                     |
      |                         | 20 existing category + empty parent id + new title of existing parent (postponed) |                         |                                               | All Products / existing category 20 (updated)                                                                                                                                                                                                                                          |                                    |                                 |                                    |                                          |                                   |                                |                                   |                                         |                                   |                                |                                   |                                         |                               |                            |                               |                                      |                             |                          |                             |                                    |                                 |                                  |                                 |                                     |
      |                         | existing category 20 (updated)                                                    |                         |                                               | All Products                                                                                                                                                                                                                                                                           |                                    |                                 |                                    |                                          |                                   |                                |                                   |                                         |                                   |                                |                                   |                                         |                               |                            |                               |                                      |                             |                          |                             |                                    |                                 |                                  |                                 |                                     |
      |                         | 21 existing category can be updated                                               |                         | 21 existing category can be updated (english) | All Products                                                                                                                                                                                                                                                                           |                                    | Short description updated       |                                    | Short description updated (english)      |                                   | Long description updated       |                                   | Long description updated (english)      |                                   | Meta description updated       |                                   | Meta description updated                |                               | Meta keywords updated      |                               | Meta keywords updated (english)      |                             | Meta titles updated      |                             | Meta titles updated (english)      |                                 | existing-category-filled-updated |                                 | existing-category-filled-updated-en |
      |                         | category with tree level 5                                                        |                         |                                               | All Products / 13 existing category + empty parent id + existing parent title / 13.1 existing category + empty parent id + existing parent title / 13.2 existing category + empty parent id + existing parent title / 13.3 existing category + empty parent id + existing parent title |                                    |                                 |                                    |                                          |                                   |                                |                                   |                                         |                                   |                                |                                   |                                         |                               |                            |                               |                                      |                             |                          |                             |                                    |                                 |                                  |                                 |                                     |
      |                         | 3 new category + existing parent id + empty parent title                          |                         |                                               | All Products                                                                                                                                                                                                                                                                           |                                    |                                 |                                    |                                          |                                   |                                |                                   |                                         |                                   |                                |                                   |                                         |                               |                            |                               |                                      |                             |                          |                             |                                    |                                 |                                  |                                 |                                     |
      |                         | 4 new category + empty parent id + empty parent title                             |                         |                                               | All Products                                                                                                                                                                                                                                                                           |                                    |                                 |                                    |                                          |                                   |                                |                                   |                                         |                                   |                                |                                   |                                         |                               |                            |                               |                                      |                             |                          |                             |                                    |                                 |                                  |                                 |                                     |
      |                         | 5 new category + empty parent id + existing parent title                          |                         |                                               | All Products                                                                                                                                                                                                                                                                           |                                    |                                 |                                    |                                          |                                   |                                |                                   |                                         |                                   |                                |                                   |                                         |                               |                            |                               |                                      |                             |                          |                             |                                    |                                 |                                  |                                 |                                     |
      |                         | 6 new category + empty parent id + title of new category (postponed)              |                         |                                               | All Products                                                                                                                                                                                                                                                                           |                                    |                                 |                                    |                                          |                                   |                                |                                   |                                         |                                   |                                |                                   |                                         |                               |                            |                               |                                      |                             |                          |                             |                                    |                                 |                                  |                                 |                                     |
      |                         | 7 new category + empty parent id + title of new category                          |                         |                                               | All Products                                                                                                                                                                                                                                                                           |                                    |                                 |                                    |                                          |                                   |                                |                                   |                                         |                                   |                                |                                   |                                         |                               |                            |                               |                                      |                             |                          |                             |                                    |                                 |                                  |                                 |                                     |
      |                         | 7.1 new category + empty parent id + title of new category                        |                         |                                               | All Products / 7 new category + empty parent id + title of new category                                                                                                                                                                                                                |                                    |                                 |                                    |                                          |                                   |                                |                                   |                                         |                                   |                                |                                   |                                         |                               |                            |                               |                                      |                             |                          |                             |                                    |                                 |                                  |                                 |                                     |
      |                         | 7.2 new category + empty parent id + title of new category                        |                         |                                               | All Products / 7 new category + empty parent id + title of new category / 7.1 new category + empty parent id + title of new category                                                                                                                                                   |                                    |                                 |                                    |                                          |                                   |                                |                                   |                                         |                                   |                                |                                   |                                         |                               |                            |                               |                                      |                             |                          |                             |                                    |                                 |                                  |                                 |                                     |
      |                         | 7.3 new category + empty parent id + title of new category                        |                         |                                               | All Products / 7 new category + empty parent id + title of new category / 7.1 new category + empty parent id + title of new category / 7.2 new category + empty parent id + title of new category                                                                                      |                                    |                                 |                                    |                                          |                                   |                                |                                   |                                         |                                   |                                |                                   |                                         |                               |                            |                               |                                      |                             |                          |                             |                                    |                                 |                                  |                                 |                                     |
      |                         | new category 1                                                                    |                         |                                               | All Products                                                                                                                                                                                                                                                                           |                                    |                                 |                                    |                                          |                                   |                                |                                   |                                         |                                   |                                |                                   |                                         |                               |                            |                               |                                      |                             |                          |                             |                                    |                                 |                                  |                                 |                                     |
      |                         | new category 2                                                                    |                         |                                               | All Products                                                                                                                                                                                                                                                                           |                                    |                                 |                                    |                                          |                                   |                                |                                   |                                         |                                   |                                |                                   |                                         |                               |                            |                               |                                      |                             |                          |                             |                                    |                                 |                                  |                                 |                                     |
      |                         | 17 new category + empty parent id + new title of existing parent                  |                         |                                               | All Products / existing category 18 (updated)                                                                                                                                                                                                                                          |                                    |                                 |                                    |                                          |                                   |                                |                                   |                                         |                                   |                                |                                   |                                         |                               |                            |                               |                                      |                             |                          |                             |                                    |                                 |                                  |                                 |                                     |
      |                         | 18 new category + empty parent id + old title of existing parent                  |                         |                                               | All Products / existing category 18 (updated)                                                                                                                                                                                                                                          |                                    |                                 |                                    |                                          |                                   |                                |                                   |                                         |                                   |                                |                                   |                                         |                               |                            |                               |                                      |                             |                          |                             |                                    |                                 |                                  |                                 |                                     |
      |                         | 22 new filled category                                                            |                         | 22 new filled category (english)              | All Products                                                                                                                                                                                                                                                                           |                                    | New category short description  |                                    | New category short description (english) |                                   | New category long description  |                                   | New category long description (english) |                                   | New category meta description  |                                   | New category meta description (english) |                               | New category meta keywords |                               | New category meta keywords (english) |                             | New category meta titles |                             | New category meta titles (english) |                                 | new-category-filled              |                                 | new-category-filled-en              |
      |                         | 23 "c@t+e3g,O\r=y"/'with' `/` $s:p-e_c+i%a^l; {[(<#chars&>)]}*.                   |                         |                                               | All Products                                                                                                                                                                                                                                                                           |                                    |                                 |                                    |                                          |                                   |                                |                                   |                                         |                                   |                                |                                   |                                         |                               |                            |                               |                                      |                             |                          |                             |                                    |                                 |                                  |                                 |                                     |
      |                         | 6.1 new category + empty parent id + title of new category (postponed)            |                         |                                               | All Products / 6 new category + empty parent id + title of new category (postponed)                                                                                                                                                                                                    |                                    |                                 |                                    |                                          |                                   |                                |                                   |                                         |                                   |                                |                                   |                                         |                               |                            |                               |                                      |                             |                          |                             |                                    |                                 |                                  |                                 |                                     |
      |                         | 19 new category + empty parent id + new title of existing parent (postponed)      |                         |                                               | All Products / existing category 20 (updated)                                                                                                                                                                                                                                          |                                    |                                 |                                    |                                          |                                   |                                |                                   |                                         |                                   |                                |                                   |                                         |                               |                            |                               |                                      |                             |                          |                             |                                    |                                 |                                  |                                 |                                     |
      |                         | 6.2 new category + empty parent id + title of new category (postponed)            |                         |                                               | All Products / 6 new category + empty parent id + title of new category (postponed) / 6.1 new category + empty parent id + title of new category (postponed)                                                                                                                           |                                    |                                 |                                    |                                          |                                   |                                |                                   |                                         |                                   |                                |                                   |                                         |                               |                            |                               |                                      |                             |                          |                             |                                    |                                 |                                  |                                 |                                     |
      |                         | 6.3 new category + empty parent id + title of new category (postponed)            |                         |                                               | All Products / 6 new category + empty parent id + title of new category (postponed) / 6.1 new category + empty parent id + title of new category (postponed) / 6.2 new category + empty parent id + title of new category (postponed)                                                  |                                    |                                 |                                    |                                          |                                   |                                |                                   |                                         |                                   |                                |                                   |                                         |                               |                            |                               |                                      |                             |                          |                             |                                    |                                 |                                  |                                 |                                     |
